import { SimpleGitTask } from './tasks/task';
import { GitExecutorEnv, outputHandler } from './types';
export declare class GitExecutor {
    binary: string;
    cwd: string;
    private _chain;
    private _queue;
    env: GitExecutorEnv;
    outputHandler?: outputHandler;
    constructor(binary: string, cwd: string);
    push<R>(task: SimpleGitTask<R>): Promise<void | R>;
    private attemptTask;
    private onFatalException;
    private attemptRemoteTask;
    private attemptEmptyTask;
    private handleTaskData;
    private gitResponse;
}
